<template>
  <nuxt-link
    ref="link"
    :to="profilLink({ name: 'activites-id', params: { id: event.activite.id } })"
    class="vuecal__event-title is-size-7"
    :class="eventClass"
    :style="eventStyle"
  >
    <div class="columns is-vcentered is-mobile mt-activite" @mouseover="afficherActivite" @mouseleave="cacherActivite">
      <div v-if="isStartDay || isStartOfWeek" :style="textStyle" class="column">
        <div class="mt-cal-activity-text has-text-weight-bold">
          <b-icon
            v-if="(activitesEnfants && activitesEnfants.length > 0) || event.activite.idParent"
            class="mt-icon"
            icon="share-variant"
            size="is-small"
          ></b-icon>
          <b-icon
            v-if="event.activite.participantsGroupe && event.activite.participantsGroupe.length > 0"
            class="mt-icon"
            icon="account-group"
            size="is-small"
          ></b-icon>
          {{ event.title }}
        </div>
      </div>
      <div v-if="isEndDay && !isStartDay && !isStartOfWeek" class="column is-hidden-mobile">&nbsp;</div>
      <div v-if="!isEndDay && !isStartDay && !isStartOfWeek" class="column is-hidden-mobile">&nbsp;</div>
      <div v-if="isEndDay" class="column mt-progress is-hidden-mobile">
        <mt-progress-activity v-if="!isEmploye" :activite="event.activite" />
      </div>
    </div>
  </nuxt-link>
</template>

<script>
import { DateTime, Interval } from 'luxon';
import MtProgressActivity from '~/components/activity/progress-users-activity';
import { classResolver } from '~/components/mixins/activityMixin';
import userMixin from '~/components/mixins/userMixin';

export default {
  name: 'MtEvent',
  components: {
    MtProgressActivity,
  },
  mixins: [classResolver, userMixin],
  props: {
    view: {
      type: String,
      default: () => '',
    },
    interval: {
      type: Object,
      default: () => ({}),
    },
    event: {
      type: Object,
      default: () => ({}),
    },
    positionActivitesParJour: {
      type: Object,
      default: () => ({}),
    },
    selectedGroupes: {
      type: Array,
      default: () => [],
    },
    isMyActivities: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    const cellDateTime = DateTime.fromISO(this.$parent.cellFormattedDate);
    const startDateTime = DateTime.fromJSDate(this.event.startDate);
    const endDatetime = DateTime.fromJSDate(this.event.endDate);
    const isStartDay = cellDateTime.hasSame(startDateTime, 'day');
    const isStartOfWeek = cellDateTime.weekday === 1;
    const isEndDay = cellDateTime.hasSame(endDatetime, 'day');

    const intervalFin = Interval.fromDateTimes(this.interval.end.minus({ days: 28 }), this.interval.end);

    const needBottomPopUp = intervalFin.contains(cellDateTime);
    return {
      cellDateTime,
      endDatetime,
      startDateTime,
      isStartDay,
      isEndDay,
      isStartOfWeek,
      stylePopup: {
        left: 'unset',
        top: 'unset',
        bottom: 'unset',
      },
      afficher: false,
      needBottomPopUp,
      activitesEnfants: null,
      activiteParent: null,
    };
  },
  computed: {
    eventClass() {
      let prefix = 'mt-background-type-';
      if (this.isAfficheFondBlanc()) {
        prefix = 'mt-my-activities-background-type-';
      }
      const classes = [this.resolveTypeActivite(this.event.activite, prefix).class];
      const cellDateTime = DateTime.fromISO(this.$parent.cellFormattedDate);
      const startDateTime = DateTime.fromJSDate(this.event.startDate);
      const endDatetime = DateTime.fromJSDate(this.event.endDate);
      const isStartDay = cellDateTime.hasSame(startDateTime, 'day');
      const isEndDay = cellDateTime.hasSame(endDatetime, 'day');
      const isStartOfWeek = cellDateTime.weekday === 1;
      if (isStartDay) {
        classes.push('mt-is-start-day');
      }
      if (isStartOfWeek) {
        classes.push('mt-is-start-week');
      }
      if (isEndDay) {
        classes.push('mt-is-end-day');
      }
      if (!isStartDay && !isEndDay) {
        classes.push('mt-is-middle-day');
      }
      this.startDay(isStartDay);
      this.endDay(isEndDay);
      return classes;
    },
    eventStyle() {
      let positionTop = 0;
      // @TODO à corriger : test mis pour eviter les plantage, mais les activité ce cumul sur les 4 derniers jour du calendrier
      if (this.positionActivitesParJour[this.$parent.cellFormattedDate]) {
        positionTop = this.positionActivitesParJour[this.$parent.cellFormattedDate][this.event.activite.id];
      }
      return {
        top: `${positionTop * 16 + (positionTop ? positionTop * 2 : 0)}px`,
      };
    },
    textStyle() {
      const style = {};
      if (this.event.daysCount <= 1) {
        style.paddingRight = '0';
      }
      const daysDiff = Math.floor(this.endDatetime.diff(this.cellDateTime, 'days').toObject().days);
      style.maxWidth = `calc(${(daysDiff + 1) * 100}% - 30px)`;
      return style;
    },
  },
  async created() {
    if (this.event.activite.idParent) {
      this.activiteParent = await this.$api.activites.getParent(this.event.activite.id);
    }
    this.activitesEnfants = await this.$api.activites.getEnfants(this.event.activite.id);
  },
  methods: {
    afficherActivite() {
      this.afficher = true;
      this.stylePopup.left = `calc(${this.$refs.link.$el.getBoundingClientRect().left.toFixed(0)}px + 1rem)`;
      if (this.needBottomPopUp) {
        this.stylePopup.bottom = `calc(100vh -  ${this.$refs.link.$el
          .getBoundingClientRect()
          .bottom.toFixed(0)}px + 2rem)`;
      } else {
        this.stylePopup.top = `calc(${this.$refs.link.$el.getBoundingClientRect().top.toFixed(0)}px + 1rem)`;
      }
      this.$emit('affiche-pop-up', {
        activite: this.event.activite,
        afficher: this.afficher,
        stylePopup: this.stylePopup,
        activiteParent: this.activiteParent,
        activitesEnfants: this.activitesEnfants,
      });
    },
    cacherActivite() {
      this.afficher = false;
      this.$emit('cacher-pop-up');
    },
    isAfficheFondBlanc() {
      if (this.isEmploye) {
        return this.event.activite.participants.length === 0 && !this.isMyActivities;
      }
      return (
        this.event.activite.participantsGroupe &&
        !this.event.activite.participantsGroupe.length > 0 &&
        this.selectedGroupes.length > 0
      );
    },
    startDay(value) {
      this.isStartDay = value;
    },
    endDay(value) {
      this.isEndDay = value;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.vuecal__event-title {
  position: absolute;
  padding: 0 5px;
  text-align: left;
  overflow: visible;
  white-space: nowrap;
  text-overflow: ellipsis;
  display: block;
  height: 0.875rem;
  font-size: 0.625rem !important;
  --margin-size: 0.4rem;
  border-width: 1px;
  border-style: solid;
}
.vuecal__cell--out-of-scope .vuecal__event-title > .mt-activite:after {
  content: '';
  position: absolute;
  top: -1px;
  left: -1px;
  right: -1px;
  bottom: -1px;
  box-shadow: 0 0 0 100rem rgba(255, 255, 255, 0.4) inset;
  user-select: auto;
  z-index: 3;
}
.mt-is-start-day {
  border-bottom-left-radius: 2em;
  border-top-left-radius: 2em;
  border-right-style: none;
  z-index: 3; /*sert à mettre le texte de l'activité devant les autres activités*/
}
.mt-is-start-week {
  z-index: 3; /*sert à mettre le texte de l'activité devant les autres activités*/
}
.mt-is-start-day:hover {
  z-index: 10; /* pour que la pop up activité soit au dessus des autre start*/
}
.mt-is-end-day {
  border-bottom-right-radius: 2em;
  border-top-right-radius: 2em;
  border-left-style: none;
}
.mt-is-middle-day {
  border-right-style: none;
  border-left-style: none;
}

.mt-is-start-day,
.mt-is-end-day {
  overflow-y: visible;
  width: calc(100% - var(--margin-size));
}
.mt-is-start-day.mt-is-end-day {
  width: calc(100% - var(--margin-size) * 2);
  border-right-style: solid;
  border-left-style: solid;
}
.mt-is-middle-day {
  width: 100%;
}
.mt-is-start-day {
  margin-left: var(--margin-size);
}
.mt-cal-activity-text {
  overflow: hidden;
  text-overflow: ellipsis;
  text-transform: uppercase;
  font-size: inherit;
  margin-top: -0.1rem;
}
.mt-progress {
  max-width: 30px;
  margin-top: -0.1rem;
}
/deep/ {
  .progress {
    border: 1px solid transparent;
    height: 0.35rem;
    background-color: $white-1;
  }
}
.mt-icon {
  margin-top: -0.1rem;
}
</style>
